{*********************************************************}
{*                                                       *}
{*   UNIT:           B G I 1 6              01.12.95     *}
{*                                                       *}
{*  includes Standard BGI-Treiber EGAVGA.BGI             *}
{*-------------------------------------------------------*}
{*                                                       *}
{*  InitGraphics     start EGA/VGA 16 color mode         *}
{*  CloseGraphics    return to text mode                 *}
{*                                                       *}
{*********************************************************}

UNIT Bgi16;

INTERFACE

procedure InitGraphics (graphMode: integer);
procedure CloseGraphics;

const                             {___graphMode___}
  detect = 0;
  EGA640x200x16	= 1;              {0:VgaLo  Standard EGA/VGA}
  EGA640x350x16	= 2;	            {1:VgaMid Standard EGA/VGA}
  VGA640x480x16	= 3;	            {2:VgaHi  Standard VGA}

{*********************************************************}
IMPLEMENTATION  uses  graph;

procedure EgaVgaDriverProc; external;
{$L EgaVga.OBJ}

const exitSave: Pointer = nil;
      graphDriverActive: boolean = false;
      grError: integer = grOK;

{*********************************************************}
procedure CloseGraphics;

begin
{
writeln (tst, 'BGI16.CloseGraphics');
}
  if exitSave <> nil
  then begin
    exitProc := exitSave;
    exitSave := nil;
    if graphDriverActive
    then graph.CloseGraph
    else RestoreCrtMode;
{
    writeln (tst,'  BGI16.CloseGraphics: '
                ,PointerString(exitProc));
}
  end
  else RestoreCrtMode;
end;
{*********************************************************}
procedure InitGraphics (graphMode: integer);

var   gd,gm: integer;

begin
  gm := graphMode;
  gd := InstallUserDriver ('EgaVga', nil);
  grError := RegisterBGIdriver (@EgaVgaDriverProc);
  if grError < 0
  then begin
    writeln ('Graphics error at RegisterBGIdriver');
    Halt(222);
  end;
  if gm = detect then DetectGraph (gd,gm)
  else begin
    gd := VGA;
    dec (gm);
  end;
  Graph.InitGraph (gd, gm, '');
  grError := GraphResult;
{
writeln (tst, 'BGI16.InitGraphics: ',gd:5, gm:5, gError:5);
}
  if grError <> grOK
  then begin
    write ('Graphics error ',grError,': ');
    writeln (GraphErrorMsg(grError));
    Halt (230);
  end;
  exitSave := ExitProc;                { save previous exit proc }
  ExitProc := @CloseGraphics;          { insert our exit proc in chain }
end;

end.
